/*
 * Copyright (C) 1997-98 Knut Anders Hatlen <kahatlen@online.no>
 *
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <stdio.h>
#include "pwgen.h"

void printversion ();
void printhelpscreen ();

int
main (int argc, char **argv)
{
  char *passwd;
  struct option args;

  args = parse_args (argc, argv);

  if (args.help)
    {
      printversion ();
      printhelpscreen ();
      exit (0);
    }

  if (args.version)
    {
      printversion ();
      exit (0);
    }

  passwd = gen_password (args.type, args.len);
  if (args.quiet)
    printf ("%s\n", passwd);
  else
    printf ("Generated password: %s\n", passwd);


  exit (0);
}

void
printversion ()
{
  printf ("Password Generator version %s, patchlevel %i\n"
	  "Copyright (C) 1997-98 Knut Anders Hatlen <kahatlen@online.no>\n"
	  "This is free software distributed under the terms of the GNU\n"
	  "General Public License, described in the file COPYING.\n"
	  ,VERSION, PATCHLEVEL);
}
void
printhelpscreen ()
{
  printf ("\nUsage:\n"
	  "\tpwgen [ options ] [ length ]\n\n"
	  "\tOptions:\n"
	  "\t\tv\tprint version number\n"
	  "\t\th\tprint this screen\n"
	  "\t\tq\tquiet (script mode)\n"
	  "\t\tn\tnot quiet\n"
	  "\t\tl\tgenerate lower case passwords\n"
	  "\t\tm\tgenerate mixed case passwords\n"
	  "\t\tu\tgenerate upper case passwords\n"
    );
}
